Oracle Coherence for C++ API
Release 3.6.1.0
E18813-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# TypedExtractor Class Template Reference

`#include <coherence/util/extractor/TypedExtractor.hpp>`

Inherits ReflectionExtractor.

Inherited by BoxExtractor.

List of all members.

## Detailed Description

### template<class R, class C, R(C::*)() const M, class RH = Object::Holder, class OH = typename C::Holder>
class coherence::util::extractor::TypedExtractor< R, C, M, RH, OH >

Template based ValueExtractor implementation.

This extractor functions on const methods which return Objects, for an extractor which works with non-Object return types see BoxExtractor.

For ease of use the COH_TYPED_EXTRACTOR macro can be used to easily construct an instance of this class. For example the following constructs an extractor for calling the "String::View Address::getState() const" method.

     ValueExtractor::View vExt = COH_TYPED_EXTRACTOR(String::View, Address, getState);

Author:
  mf 2009.03.20

See also:
  BoxExtractor

## Public Types
typedef spec::Handle | Handle
| TypedExtractor<R, C, M, RH, OH> Handle definition.
typedef spec::View | View
| TypedExtractor<R, C, M, RH, OH> View definition.
typedef spec::Holder | Holder
| TypedExtractor<R, C, M, RH, OH> Holder definition.
## Public Member Functions
virtual Object::Holder | extract (Object::Holder ohTarget) const
  | Extract the value from the passed object. The returned value may be NULL. Parameters:
  | ohTarget | an Object to retrieve the value from
  Returns: the extracted value; NULL is an acceptable value Exceptions:
  | ClassCastException | if this ValueExtractor is incompatible with the passed object to extract a value from and the implementation requires the passed object to be of a certain type
  | Exception | if this ValueExtractor encounters an exception in the course of extracting the value
  | IllegalArgumentException | if this ValueExtractor cannot handle the passed object for any other reason; an implementor should include a descriptive message
  Exceptions:
  | UnsupportedOperationException | always
virtual bool | equals (Object::View v) const
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
## Protected Member Functions
| TypedExtractor ()
| Construct a TypedExtractor.
| TypedExtractor (String::View vsMethod)
| Construct a TypedExtractor based on a method name and optional parameters.

## Constructor & Destructor Documentation

TypedExtractor | ( | String::View | vsMethod | ) | `[inline, protected]`

Construct a TypedExtractor based on a method name and optional parameters.

The method name is only used for the purposes of serializing the extractor for execution on remote Java members.

Parameters:

  | vsMethod | the name of the method to invoke via reflection

The documentation for this class was generated from the following file:

- coherence/util/extractor/TypedExtractor.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.